///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
//                ACUARIO v0.3 beta
//    incluye bombas de dosificacin, bomba de reposicin de agua, un termmetros
//    encendido de lamparas y revisado el tratamiento de reles, aado los botones
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

//para la hora
#include <Wire.h>
#define DS1307_I2C_ADDRESS 0x68
byte second, minute, hour, dayOfWeek, dayOfMonth, month, year; // variables para la hora
// LED de control
byte ledPin = 13;
// para el shifting
byte latchPin = 8; //Pin conectado a ST_CP of 74HC595
byte clockPin = 12; //Pin conectado a SH_CP of 74HC595
byte dataPin = 11; // hay que pasarlo al 13 y anular led  //Pin conectado a DS of 74HC595
//para la alarma
byte alarmapin = 2; //salida para el pitido
//para el nivel de agua
byte aguaPin = 7; //la entrada del sensor
boolean agua = 0; //el estado del sensor
byte diaagua = 0; //para las estadisticas
int contaagua = 0; //para las estadisticas
int contaaguaant1 = 0; //para las estadisticas
int contaaguaant2 = 0; //para las estadisticas
int contaaguaant3 = 0; //para las estadisticas
//para la temperatura
byte ventiladorPin = 9; //Pin control de velocidad ventilador PVM
byte tempPinA = 4; //Pin de temperatura acuario
byte vueltas = 0; //historico velocidad ventilador 1
byte vueltas1 = 0, vueltas2 = 0, vueltas3 = 0, vueltas4 = 0, vueltas5 = 0, vueltas6 = 0, vueltas7 = 0; //historico velocidad ventilador 1
int TReading;   // variables temperatura
const int Tempmin = 385;
const int Temp1 = 424; // 390=24,0/418=26,1/424=26,5/432=27/440=27,5
const int Temp2 = 432;
const int Temp3 = 440;
int Whole, Fract;
// contadores para visualizacion
int visualizar1 = 1000; //agua
int visualizar2 = 1000; //ventilador
//Todos los reles
boolean rele1=0; // compA
boolean rele2=0; // ventilador 1
boolean rele3=0; // ventilador 2
boolean rele4=0; // calentador
//
boolean rele5=0; // peristaltica relleno agua
boolean rele6=0; // compB
boolean rele7=0; // luz principal
boolean rele8=0; // luna
//variables horas encendido
const byte horaluz = 14;    //hora encendido
const byte horanoluz = 1;    //hora apagado
//variables componentes
const byte comphora = 11; //hora para aadir componetes
const byte comphora2 = 17; //hora para aadir componetes
const byte compmin = 5;    //minutos +5 para bomba revuelve
const byte compseca = 15;    //tiempo bomba A = 3,6ml/10sec
const byte compsecb = 15;    //tiempo bomba B = 3,6ml/10sec
//variables para las bombas
byte bomba1Pin = 5;
byte bomba2Pin = 6;
byte bomba1 = 255; //para el PWM de la bomba 1
byte bomba2 = 255; //para el PWM de la bomba 2
int tiempobomba = 60; // tiempo aleatorio de cambio de bombas
int retardobomba = 1000; //contador para cambio de bombas
//para los botones
byte botonPin = 3;
char msgs[5][6] = {"uno ", 
                   "dos ", 
                   "tres", 
                   "cuar", 
                   "quin" };
int  adc_key_val[5] ={30, 150, 360, 535, 760 };
int NUM_KEYS = 5;
int adc_key_in;
int key=-1;
int oldkey=-1;
boolean presskey=0;



void setup() {
  Serial.begin(9600);
  //declaracion de pines
  pinMode(latchPin, OUTPUT);
  pinMode(alarmapin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  pinMode(ledPin, OUTPUT);      // para las luces
  pinMode(ventiladorPin, OUTPUT);  
  pinMode(bomba1Pin, OUTPUT);  
  pinMode(bomba2Pin, OUTPUT);  
  pinMode(aguaPin, INPUT);
  digitalWrite(tempPinA, LOW);
  pinMode(tempPinA, INPUT);  // sets the digital pin as input (logic 1)
  Wire.begin();
  Serial.print("?c0?f"); // quita cursor y limpia el LCD /  Serial.print("?G420"); define geometria
  delay(1000);
  Serial.print("?y0?x05Controlador");
  Serial.print("?y1?x05Acuario  V3");
  Serial.print("?y2?x04by Carballada");
  Serial.print("?y3?x065/10/08");
  delay(2000);
  Serial.print("?f"); 
  randomSeed(analogRead(0));
}

void loop() {

  // enciende LED de control
  digitalWrite(ledPin, HIGH); 

  //lee la hora
  getDateDs1307();

  // apaga LED de control
  digitalWrite(ledPin, LOW); 
 
  //empieza lectura del termometro  del acuario (tiene 1 segundo de retraso)
  mira_temp(tempPinA);
 
  //  Cambia la velocidad del ventilador en funcion de temperatura
  velocidad_ventilador();

  //  Cambia la velocidad de las bombas de circulacion
  velocidad_bombas();

  // Mira el nivel del agua
  nivel_agua();
 
  //iluminacin
  iluminacion();

  //mete componentes
  aditivos();

  // cada 5 minutos cambia reles de temperatura y toma contramedidas
  control_temperatura();

  // activa la alarma si hay problemas
  control_alarma();
  
  //imprime LCD
  salida_lcd(); 
  
  // lee botones y actua
  mira_botones();
  
  //graba los rels
  shiftOut();
  

  
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// empiezan las funciones detalladas
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////
// para el shift
//////////////
void shiftOut() {
  //ground latchPin and hold low for as long as you are transmitting
  digitalWrite(latchPin, 0);
  //clear everything out just in case to
  //prepare shift register for bit shifting
  digitalWrite(dataPin, 0);
  digitalWrite(clockPin, 0);
  //para cada rele independiente
  shiftrel(rele8);
  shiftrel(rele7);
  shiftrel(rele6);
  shiftrel(rele5);
  shiftrel(rele4);
  shiftrel(rele3);
  shiftrel(rele2);
  shiftrel(rele1);

  //stop shifting
  digitalWrite(clockPin, 0);
  //return the latch pin high to signal chip that it
  //no longer needs to listen for information
  digitalWrite(latchPin, 1);
 
}
void shiftrel(byte rel) {
    digitalWrite(clockPin, 0);
    digitalWrite(dataPin, rel);
    digitalWrite(clockPin, 1);
    digitalWrite(dataPin, 0);
}

//////////////////////
// para el 1wire de los termometros
///////////////////////
void OneWireReset(int _1W_Pin) { // reset.  Should improve to act as a presence pulse
     digitalWrite(_1W_Pin, LOW);
     pinMode(_1W_Pin, OUTPUT); // bring low for 500 us
     delayMicroseconds(500);
     pinMode(_1W_Pin, INPUT);
     delayMicroseconds(500);
}
void OneWireOutByte(int _1W_Pin, byte d, byte strong) { // output byte d (least sig bit first).
   byte n;
   for(n=8; n!=0; n--)
   {  if ((d & 0x01) == 1)  // test least sig bit
      { digitalWrite(_1W_Pin, LOW);
        pinMode(_1W_Pin, OUTPUT);
        delayMicroseconds(5);
        pinMode(_1W_Pin, INPUT);
        delayMicroseconds(60);
      }
      else
      { digitalWrite(_1W_Pin, LOW);
        pinMode(_1W_Pin, OUTPUT);
        delayMicroseconds(60);
        pinMode(_1W_Pin, INPUT);
      }
      d=d>>1; // now the next bit is in the least sig bit position.
   }
   if(strong)
   {   digitalWrite(_1W_Pin, HIGH); // One sec of strong +5 VDC
       pinMode(_1W_Pin, OUTPUT);
       delay(1000);
       pinMode(_1W_Pin, INPUT);
       digitalWrite(_1W_Pin, LOW);
   }
}

byte OneWireInByte(int _1W_Pin) { // read byte, least sig byte first
    byte d, n, b;
    for (n=0; n<8; n++)
    {   digitalWrite(_1W_Pin, LOW);
        pinMode(_1W_Pin, OUTPUT);
        delayMicroseconds(5);
        pinMode(_1W_Pin, INPUT);
        delayMicroseconds(5);
        b = digitalRead(_1W_Pin);
        delayMicroseconds(50);
        d = (d >> 1) | (b<<7); // shift d to right and insert b in most sig bit position
    }
    return(d);
}
// imprime la temperatura y la devuelve
void mira_temp(int tempPinx) {
  int Tc_100, sign, HighByte, LowByte, SignBit;
 
  OneWireReset(tempPinx);
  OneWireOutByte(tempPinx, 0xcc, 0);
  OneWireOutByte(tempPinx, 0x44, 1); // perform temperature conversion, strong pullup for one sec

  OneWireReset(tempPinx);
  OneWireOutByte(tempPinx, 0xcc, 0);
  OneWireOutByte(tempPinx, 0xbe, 0);

  LowByte = OneWireInByte(tempPinx);
  HighByte = OneWireInByte(tempPinx);
  TReading = (HighByte << 8) + LowByte;
  SignBit = TReading & 0x8000;  // test most sig bit
  if (SignBit) // negative
  {
    TReading = (TReading ^ 0xffff) + 1; // 2's comp
  }
  Tc_100 = (6 * TReading) + TReading / 4;    // multiply by (100 * 0.0625) or 6.25
  Whole = Tc_100 / 100;  // separate off the whole and fractional portions
  Fract = Tc_100 % 100;
}


////////////////////
//para obtener la hora
////////////////////

// Convert normal decimal numbers to binary coded decimal
byte decToBcd(byte val) { return ( (val/10*16) + (val%10) );}
// Convert binary coded decimal to normal decimal numbers
byte bcdToDec(byte val) {  return ( (val/16*10) + (val%16) );}

// Gets the date and time from the ds1307
void getDateDs1307() {
  // Reset the register pointer
  Wire.beginTransmission(DS1307_I2C_ADDRESS);
  Wire.send(0);
  Wire.endTransmission();
  Wire.requestFrom(DS1307_I2C_ADDRESS, 7);
  // A few of these need masks because certain bits are control bits
  second     = bcdToDec(Wire.receive() & 0x7f);
  minute     = bcdToDec(Wire.receive());
  hour       = bcdToDec(Wire.receive() & 0x3f);  // Need to change this if 12 hour am/pm
  dayOfWeek  = bcdToDec(Wire.receive());
  dayOfMonth = bcdToDec(Wire.receive());
  month      = bcdToDec(Wire.receive());
  year       = bcdToDec(Wire.receive());
}

// imprime la hora
void printDate() {
  printDec2(hour); Serial.print(":");
  printDec2(minute); Serial.print(":");
  printDec2(second); Serial.print(" ");
  printDec2(dayOfMonth); Serial.print("/");
  printDec2(month); Serial.print(" ");
  printDayName(dayOfWeek);
}

//imprime el dia de la semana
void printDayName(byte d) {
  switch (d) {
    case 1: Serial.print("LU");     break;
    case 2: Serial.print("MA");     break;
    case 3: Serial.print("MI");     break;
    case 4: Serial.print("JU");     break;
    case 5: Serial.print("VI");     break;
    case 6: Serial.print("SA");     break;
    case 7: Serial.print("DO");     break;
    default:Serial.print("??");
  }
}

//////////////////////
// para el PWM del ventilador 1 y el hstorico
///////////////////////
void velocidad_ventilador() {
  if (TReading >= Temp1 && TReading < Temp2)
  { //si temp adecuada
    vueltas = (TReading - Temp1) * (255/(Temp2 - Temp1));
  }
  else {
    if (TReading < Temp1) { vueltas = 0; }
    if (TReading >= Temp2) { vueltas = 255; }
  }
  analogWrite(ventiladorPin, vueltas);
  //cada 600 segundos, 10 minutos, enva log de la velocidad a la pantalla
  if (visualizar2 > 600)
  {
    visualizar2 = 1;    
    vueltas7 = vueltas6;
    vueltas6 = vueltas5;
    vueltas5 = vueltas4;
    vueltas4 = vueltas3;
    vueltas3 = vueltas2;
    vueltas2 = vueltas1;
    vueltas1 = vueltas;
  }
  else
  {
    ++visualizar2;
  }
}

//////////////////////
// para el PWM de las bombas cada 60 segundos
///////////////////////
void velocidad_bombas() {
    if (retardobomba > tiempobomba)
  {
    retardobomba = 1;    
    bomba1 = random(0, 256);
    analogWrite(bomba1Pin, bomba1);
    bomba2 = random(0, 256);
    analogWrite(bomba2Pin, bomba2);
    tiempobomba = random(60, 1201);
  }
  else
  {
    ++retardobomba;
  }
}

//////////////////////
// mira el nivel, activa la bomba y escribe en pantalla con acumulados
///////////////////////
void nivel_agua() {
  agua = digitalRead(aguaPin);
  if (!agua)
  {
    rele5=1;
    if (dayOfMonth == diaagua)
    {
        ++contaagua;
    }
    if (dayOfMonth != diaagua)
    {
        diaagua = dayOfMonth;
        contaaguaant3 = contaaguaant2;
        contaaguaant2 = contaaguaant1;
        contaaguaant1 = contaagua / 60;
        contaagua = 0;
    }
  }
  else
  {  rele5=0;   }
}

//////////////////////
//activa reles de ventiladores y calentador y toma medidas, cada 3 minutos
///////////////////////
void control_temperatura() {
  if (visualizar1 > 180)
  {
    visualizar1=1;
  // empieza la logica de los reles
  // rele2 ventilador 1 - rele 3 ventilador 2 - rele 4 calentador
    if (TReading < Temp1 )                      { rele2= 0 ; rele3= 0; rele4= 1;} //enciende calentador
    if (TReading >= Temp1 && TReading < Temp2) { rele2= 1 ; rele3= 0; rele4= 0;} //enciende ventilador1
    if (TReading >= Temp2 && TReading < Temp3) { rele2= 1 ; rele3= 1; rele4= 0;} //enciende ventilador 1 y 2
    if (TReading >= Temp3)                      { rele2= 1 ; rele3= 1; rele4= 0; rele7 = 0; } //apaga las luces si estan encendidas
  }
  else
  {
    ++visualizar1;
  }
}

//////////////////////
//controla las peristalticas
///////////////////////
void aditivos()
{
  if ((hour == comphora or hour == comphora2) and minute >= (compmin - 5) and minute <= (compmin + 6))
    {rele8 = 1;}
  else {rele8 = 0;}
  if ((hour == comphora or hour == comphora2) and minute == compmin and second >= 1 and second <= compseca)
    {rele1 = 1;}
  else {rele1 = 0;}
  if ((hour == comphora or hour == comphora2) and minute == (compmin + 6) and second >= 1 and second <= compsecb)
    {rele6 = 1;}
  else {rele6 = 0;}
}

//////////////////////
//controla las luces
///////////////////////
void iluminacion()
{
  if (hour < horaluz && hour >= horanoluz) //luz principal
    {rele7 = 0;}
  else {rele7 = 1;}
} 

//////////////////////
//activa el pitido
///////////////////////
void control_alarma()
{
  if (TReading >= Temp3 or TReading <= Tempmin)  {
  // enciende alarma
  digitalWrite(alarmapin, HIGH); 
  }
  else {
  digitalWrite(alarmapin, LOW); 
  }
}

//////////////////////
//controla los botones apretados
///////////////////////
void mira_botones()
{
  adc_key_in = analogRead(botonPin);    // read the value from the sensor  
  key = get_key(adc_key_in);		        // convert into key press
    if (key != oldkey)				    // if keypress is detected
    {
      delay(50);		// wait for debounce time
      adc_key_in = analogRead(botonPin);    // read the value from the sensor  
      key = get_key(adc_key_in);		        // convert into key press
      if (key != oldkey)  {
        oldkey = key;
        if (key >=0){
			Serial.print("?c0?f");delay(40);
			Serial.print("?y2?x00");delay(5);
			Serial.print(msgs[key]);
			presskey = 1;}
      }
    }
}
// Convert ADC value to key number
int get_key(unsigned int input)
{
int k;
for (k = 0; k < NUM_KEYS; k++) {
    if (input < adc_key_val[k])	{ return k;  }
  }
if (k >= NUM_KEYS) k = -1;     // No valid key pressed
return k;
}
//////////////////////
//salida hacia el LCD sin casi comandos
///////////////////////
void salida_lcd()
{
  Serial.print("?y0?x00");
  Serial.print(rele8, DEC); Serial.print(rele1, DEC); //dos reles
  Serial.print(" ");
  printDate(); //la hora 
//  Serial.print("?y1?x00");
  Serial.print(rele7, DEC); Serial.print(rele2, DEC); delay(5);
  Serial.print(" "); 
  Serial.print(Whole); //temperatura
  Serial.print(".");
  printDec2(Fract); delay(5);
  Serial.print(" "); printDec3(vueltas);
  Serial.print(" ?"); Serial.print(vueltas1 * 7 / 255, DEC); delay(5);
  Serial.print("?"); Serial.print(vueltas2 * 7 / 255, DEC); delay(5);
  Serial.print("?"); Serial.print(vueltas3 * 7 / 255, DEC); delay(5);
  Serial.print("?"); Serial.print(vueltas4 * 7 / 255, DEC); delay(5);
  Serial.print("?"); Serial.print(vueltas5 * 7 / 255, DEC); delay(5);
  Serial.print("?"); Serial.print(vueltas6 * 7 / 255, DEC); delay(5);
  Serial.print("?"); Serial.print(vueltas7 * 7 / 255, DEC); delay(5);
//  Serial.print("?y2?x00");
  Serial.print(rele6, DEC); Serial.print(rele3, DEC);
  Serial.print(" ");
  printDec4(contaagua);
  Serial.print("  ");  printDec3(contaaguaant1); delay(5);
  Serial.print("/");  printDec3(contaaguaant2); delay(5);
  Serial.print("/");  printDec3(contaaguaant3); delay(5);
//  Serial.print("?y3?x00");
  Serial.print(rele5, DEC); Serial.print(rele4, DEC); delay(5);
  Serial.print(" ");
  printDec2(bomba1 * 99 /255);  Serial.print("-"); delay(5);
  printDec2(bomba2 * 99 /255);  Serial.print(" "); delay(5);
  printDec2(tiempobomba / 60);
  Serial.print(" "); delay(5);
  Serial.print(key); delay(5);
}
//imprime con dos decimales
void printDec2(byte decVal) {
  if (decVal < 10)
    Serial.print("0");
  Serial.print(decVal, DEC);
}
//imprime con tres decimales
void printDec3(int decVal2) {
  if (decVal2 > 9 && decVal2 < 100) {
    Serial.print("0");}
  if (decVal2 < 10){
    Serial.print("00");}
  Serial.print(decVal2, DEC);
}
//imprime con cuatros decimales
void printDec4(int decVal3) {
  if (decVal3 > 99 && decVal3 < 1000) {
    Serial.print("0");}
  if (decVal3 > 9 && decVal3 < 100) {
    Serial.print("00");}
  if (decVal3 < 10){
    Serial.print("000");}
  Serial.print(decVal3, DEC);
}
